/* -*- Mode: C++; tab-width: 20; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Anya client code
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation. Portions created by the Initial Developer are
 * Copyright (C) 2003 the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *    Stuart Parmenter <pavlov@netscape.com>
 *    Joe Hewitt <hewitt@netscape.com>
 *    Ben Goodger <ben@netscape.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 */

#ifndef anya_h__
#define anya_h__

#ifdef __cplusplus
extern "C" {
#endif

#include "abc.h"
#include "oztypes.h"
#include "client.h"

#define ANYA_VERSION 3
#define ANYA_PORT 6666

/* float to fixed 16.16 conversions */
/* XXX these suck. i'm sure theres a far better way to do this */
#define ftof9(x) (uint16)((x)*512.0f)
#define f9tof(x) ((float)(x)/512.0f)

#define MAX(x,y) ((x)>(y)?(x):(y))

typedef struct AnyaWindow
{
    ozWindow *window;
    ozGC gc;

    ClientData cd;
} AnyaWindow;

AnyaWindow *anya_window_create(int x, int y, int width, int height);
void        anya_window_destroy(AnyaWindow *win);
void        anya_window_load(AnyaWindow *win, const char *uri, uint8 method);

#ifdef __cplusplus
}
#endif

#endif /* anya_h__ */
