/* -*- Mode: C++; tab-width: 20; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Anya server code
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation. Portions created by the Initial Developer are
 * Copyright (C) 2003 the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *    Stuart Parmenter <pavlov@netscape.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 */

#ifndef anyaIDataTransferManager_h___
#define anyaIDataTransferManager_h___

#include "nsISupports.h"

#include "xcoder.h"
#include "idmap.h"

#define NS_ANYADATAXFERMGR_IID   \
{ 0x0a25182f, 0xebcb, 0x4bd3,    \
{ 0xa2, 0xb0, 0x85, 0x32, 0x4a, 0xe4, 0x03, 0x64 } }

class anyaIDataTransferManager : public nsISupports
{
public:
  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ANYADATAXFERMGR_IID)

  virtual XCoderStream* GetXCoder() = 0;
  virtual struct IdMap* GetIdMap() = 0;
  virtual void Inc(unsigned long n) = 0;
  virtual void IncFormCount(unsigned long n) = 0;
  virtual void Flush() = 0;
  virtual void SetRequest(struct Request* aRequest) = 0;
  virtual struct Request* GetRequest() = 0;
};

// {118321FF-61E2-4054-9741-4820E61D2724}
#define NS_ANYADATAXFERMGR_CID \
{ 0x118321ff, 0x61e2, 0x4054, { 0x97, 0x41, 0x48, 0x20, 0xe6, 0x1d, 0x27, 0x24 } }

#define NS_ANYADATAXFERMGR_CONTRACTID "@aol.com/anya/datatransfermanager;1"
#define NS_ANYADATAXFERMGR_CLASSNAME "AnyaDataTransferManager"


#define ADTM_XCODER() nsCOMPtr<anyaIDataTransferManager>(do_GetService(NS_ANYADATAXFERMGR_CONTRACTID))->GetXCoder()
#define ADTM_IDMAP()  nsCOMPtr<anyaIDataTransferManager>(do_GetService(NS_ANYADATAXFERMGR_CONTRACTID))->GetIdMap()
#define ADTM_INC(n)   nsCOMPtr<anyaIDataTransferManager>(do_GetService(NS_ANYADATAXFERMGR_CONTRACTID))->Inc(n)
#define ADTM_INCFORM(n)   nsCOMPtr<anyaIDataTransferManager>(do_GetService(NS_ANYADATAXFERMGR_CONTRACTID))->IncFormCount(n)
#define ADTM_FLUSH()  nsCOMPtr<anyaIDataTransferManager>(do_GetService(NS_ANYADATAXFERMGR_CONTRACTID))->Flush()

#endif  // anyaIDataTransferManager_h___

